
package de.ivu.elect.presentation.benutzerverwaltung;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerBoundaryCreate;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerFactory;
import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;
import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractBenutzerCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractBenutzerCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.BENUTZER_CREATE)
public abstract class AbstractBenutzerCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Benutzer> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "benutzerCreateView";

  public static final String VIEW_ID = "/benutzerverwaltung/benutzer-create.xhtml";

  public static final String PARENT_VIEW_ID = "/benutzerverwaltung/benutzer-search.xhtml";

  @Inject
  protected transient BenutzerBoundaryCreate create;

  protected Benutzer entity;

  @Inject
  protected transient BenutzerMeta entityMeta;

  
  @Inject
  protected transient BenutzerFactory factory;

  public AbstractBenutzerCreateNoScopeView() {
    super();
  }

  @PostConstruct
  public void init() {
    setEntity(factory.create());
  }

  

  public Benutzer getEntity() {
    return entity;
  }

  protected void setEntity(Benutzer entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.BENUTZER_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Benutzer entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Benutzer entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.BENUTZER_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
